3 # Copyright (c) 2006 Johannes E. Schindelin
7 # This script makes it easy to fix up commits in the middle of a series,
8 # and rearrange commits.
10 # The original idea comes from Eric W. Biederman, in
11 # http://article.gmane.org/gmane.comp.version-control.git/22407
13 # The file containing rebase commands, comments, and empty lines.
14 # This file is created by "git rebase -i" then edited by the user. As
15 # the lines are processed, they are removed from the front of this
16 # file and written to the tail of $done.
17 todo="$state_dir"/git-rebase-todo
19 # The rebase command lines that have already been processed. A line
20 # is moved here when it is first handled, before any associated user
22 done="$state_dir"/done
24 # The commit message that is planned to be used for any changes that
25 # need to be committed following a user interaction.
26 msg="$state_dir"/message
28 # The file into which is accumulated the suggested commit message for
29 # squash/fixup commands. When the first of a series of squash/fixups
30 # is seen, the file is created and the commit message from the
31 # previous commit and from the first squash/fixup commit are written
32 # to it. The commit message for each subsequent squash/fixup commit
33 # is appended to the file as it is processed.
35 # The first line of the file is of the form
36 # # This is a combination of $count commits.
37 # where $count is the number of commits whose messages have been
38 # written to the file so far (including the initial "pick" commit).
39 # Each time that a commit message is processed, this line is read and
40 # updated. It is deleted just before the combined commit is made.
41 squash_msg="$state_dir"/message-squash
43 # If the current series of squash/fixups has not yet included a squash
44 # command, then this file exists and holds the commit message of the
45 # original "pick" commit. (If the series ends without a "squash"
46 # command, then this can be used as the commit message of the combined
47 # commit without opening the editor.)
48 fixup_msg="$state_dir"/message-fixup
50 # $rewritten is the name of a directory containing files for each
51 # commit that is reachable by at least one merge base of $head and
52 # $upstream. They are not necessarily rewritten, but their children
53 # might be. This ensures that commits on merged, but otherwise
54 # unrelated side branches are left alone. (Think "X" in the man page's
56 rewritten="$state_dir"/rewritten
58 dropped="$state_dir"/dropped
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
63 author_script="$state_dir"/author-script
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
80 GIT_CHERRY_PICK_HELP="$resolvemsg"
81 export GIT_CHERRY_PICK_HELP
84 printf '%s\n' "$*" >&2
87 # Output the commit message for the specified commit.
89 git cat-file commit "$1" | sed "1,/^$/d"
92 orig_reflog_action="$GIT_REFLOG_ACTION"
94 comment_for_reflog () {
95 case "$orig_reflog_action" in
97 GIT_REFLOG_ACTION="rebase -i ($1)"
98 export GIT_REFLOG_ACTION
104 mark_action_done () {
105 sed -e 1q < "$todo" >> "$done"
106 sed -e 1d < "$todo" >> "$todo".new
107 mv -f "$todo".new "$todo"
108 new_count=$(sane_grep -c '^[^#]' < "$done")
109 total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo")))
110 if test "$last_count" != "$new_count"
112 last_count=$new_count
113 printf "Rebasing (%d/%d)\r" $new_count $total
114 test -z "$verbose" || echo
118 append_todo_help () {
119 cat >> "$todo" << EOF
122 # p, pick = use commit
123 # r, reword = use commit, but edit the commit message
124 # e, edit = use commit, but stop for amending
125 # s, squash = use commit, but meld into previous commit
126 # f, fixup = like "squash", but discard this commit's log message
127 # x, exec = run command (the rest of the line) using shell
129 # These lines can be re-ordered; they are executed from top to bottom.
131 # If you remove a line here THAT COMMIT WILL BE LOST.
136 sha1_and_parents="$(git rev-list --parents -1 "$1")"
137 case "$sha1_and_parents" in
139 git diff --cc $sha1_and_parents
142 git diff-tree -p "$1^!"
147 esac > "$state_dir"/patch
149 commit_message "$1" > "$msg"
150 test -f "$author_script" ||
151 get_author_ident_from_commit "$1" > "$author_script"
155 echo "$1" > "$state_dir"/stopped-sha
162 echo "$1" > "$state_dir"/stopped-sha
164 git rev-parse --verify HEAD > "$amend"
165 warn "You can amend the commit now, with"
167 warn " git commit --amend"
169 warn "Once you are satisfied with your changes, run"
171 warn " git rebase --continue"
182 sane_grep '^[^#]' "$1" >/dev/null
186 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
187 die "$1: not a commit that can be picked")
188 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
189 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
190 test "$tree" = "$ptree"
195 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
198 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
199 # GIT_AUTHOR_DATE exported from the current environment.
202 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
207 git_sequence_editor () {
208 if test -z "$GIT_SEQUENCE_EDITOR"
210 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
211 if [ -z "$GIT_SEQUENCE_EDITOR" ]
213 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
217 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
223 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
224 case "$force_rebase" in '') ;; ?*) ff= ;; esac
225 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
227 if is_empty_commit "$sha1"
229 empty_args="--allow-empty"
232 test -d "$rewritten" &&
233 pick_one_preserving_merges "$@" && return
234 output git cherry-pick $empty_args $ff "$@"
237 pick_one_preserving_merges () {
248 sha1=$(git rev-parse $sha1)
250 if test -f "$state_dir"/current-commit
252 if test "$fast_forward" = t
254 while read current_commit
256 git rev-parse HEAD > "$rewritten"/$current_commit
257 done <"$state_dir"/current-commit
258 rm "$state_dir"/current-commit ||
259 die "Cannot write current commit's replacement sha1"
263 echo $sha1 >> "$state_dir"/current-commit
265 # rewrite parents; if none were rewritten, we can fast-forward.
267 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
268 if test "$pend" = " "
272 while [ "$pend" != "" ]
274 p=$(expr "$pend" : ' \([^ ]*\)')
277 if test -f "$rewritten"/$p
279 new_p=$(cat "$rewritten"/$p)
281 # If the todo reordered commits, and our parent is marked for
282 # rewriting, but hasn't been gotten to yet, assume the user meant to
283 # drop it on top of the current HEAD
286 new_p=$(git rev-parse HEAD)
289 test $p != $new_p && fast_forward=f
290 case "$new_parents" in
292 ;; # do nothing; that parent is already there
294 new_parents="$new_parents $new_p"
298 if test -f "$dropped"/$p
301 replacement="$(cat "$dropped"/$p)"
302 test -z "$replacement" && replacement=root
303 pend=" $replacement$pend"
305 new_parents="$new_parents $p"
309 case $fast_forward in
311 output warn "Fast-forward to $sha1"
312 output git reset --hard $sha1 ||
313 die "Cannot fast-forward to $sha1"
316 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
320 # detach HEAD to current parent
321 output git checkout $first_parent 2> /dev/null ||
322 die "Cannot move HEAD to $first_parent"
325 case "$new_parents" in
327 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
330 author_script_content=$(get_author_ident_from_commit $sha1)
331 eval "$author_script_content"
332 msg_content="$(commit_message $sha1)"
333 # No point in merging the first parent, that's HEAD
334 new_parents=${new_parents# $first_parent}
335 if ! do_with_author output \
336 git merge --no-ff ${strategy:+-s $strategy} -m \
337 "$msg_content" $new_parents
339 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
340 die_with_patch $sha1 "Error redoing merge $sha1"
342 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
345 output git cherry-pick "$@" ||
346 die_with_patch $sha1 "Could not pick $sha1"
355 *1[0-9]|*[04-9]) echo "$1"th;;
362 update_squash_messages () {
363 if test -f "$squash_msg"; then
364 mv "$squash_msg" "$squash_msg".bak || exit
366 -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \
367 -e "q" < "$squash_msg".bak)+1))
369 echo "# This is a combination of $count commits."
370 sed -e 1d -e '2,/^./{
372 }' <"$squash_msg".bak
375 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
378 echo "# This is a combination of 2 commits."
379 echo "# The first commit's message is:"
388 echo "# This is the $(nth_string $count) commit message:"
394 echo "# The $(nth_string $count) commit message will be skipped:"
396 commit_message $2 | sed -e 's/^/# /'
401 peek_next_command () {
402 sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo"
405 # A squash/fixup has failed. Prepare the long version of the squash
406 # commit message, then die_with_patch. This code path requires the
407 # user to edit the combined commit message for all commits that have
408 # been squashed/fixedup so far. So also erase the old squash
409 # messages, effectively causing the combined commit to be used as the
410 # new basis for any further squash/fixups. Args: sha1 rest
411 die_failed_squash() {
412 mv "$squash_msg" "$msg" || exit
414 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
416 warn "Could not apply $1... $2"
420 flush_rewritten_pending() {
421 test -s "$rewritten_pending" || return
422 newsha1="$(git rev-parse HEAD^0)"
423 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
424 rm -f "$rewritten_pending"
427 record_in_rewritten() {
428 oldsha1="$(git rev-parse $1)"
429 echo "$oldsha1" >> "$rewritten_pending"
431 case "$(peek_next_command)" in
435 flush_rewritten_pending
441 if test "$(git rev-parse HEAD)" = "$squash_onto"
443 # Set the correct commit message and author info on the
444 # sentinel root before cherry-picking the original changes
445 # without committing (-n). Finally, update the sentinel again
446 # to include these changes. If the cherry-pick results in a
447 # conflict, this means our behaviour is similar to a standard
448 # failed cherry-pick during rebase, with a dirty index to
449 # resolve before manually running git commit --amend then git
451 git commit --allow-empty --allow-empty-message --amend \
452 --no-post-rewrite -n -q -C $1 &&
454 git commit --allow-empty --allow-empty-message \
455 --amend --no-post-rewrite -n -q -C $1 ||
456 die_with_patch $1 "Could not apply $1... $2"
459 die_with_patch $1 "Could not apply $1... $2"
464 rm -f "$msg" "$author_script" "$amend" || exit
465 read -r command sha1 rest < "$todo"
471 comment_for_reflog pick
474 do_pick $sha1 "$rest"
475 record_in_rewritten $sha1
478 comment_for_reflog reword
481 do_pick $sha1 "$rest"
482 git commit --amend --no-post-rewrite || {
483 warn "Could not amend commit after successfully picking $sha1... $rest"
484 warn "This is most likely due to an empty commit message, or the pre-commit hook"
485 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
486 warn "you are able to reword the commit."
487 exit_with_patch $sha1 1
489 record_in_rewritten $sha1
492 comment_for_reflog edit
495 do_pick $sha1 "$rest"
496 warn "Stopped at $sha1... $rest"
497 exit_with_patch $sha1 0
508 comment_for_reflog $squash_style
510 test -f "$done" && has_action "$done" ||
511 die "Cannot '$squash_style' without a previous commit"
514 update_squash_messages $squash_style $sha1
515 author_script_content=$(get_author_ident_from_commit HEAD)
516 echo "$author_script_content" > "$author_script"
517 eval "$author_script_content"
518 if ! pick_one -n $sha1
520 git rev-parse --verify HEAD >"$amend"
521 die_failed_squash $sha1 "$rest"
523 case "$(peek_next_command)" in
525 # This is an intermediate commit; its message will only be
526 # used in case of trouble. So use the long version:
527 do_with_author output git commit --amend --no-verify -F "$squash_msg" ||
528 die_failed_squash $sha1 "$rest"
531 # This is the final command of this squash/fixup group
532 if test -f "$fixup_msg"
534 do_with_author git commit --amend --no-verify -F "$fixup_msg" ||
535 die_failed_squash $sha1 "$rest"
537 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
538 rm -f "$GIT_DIR"/MERGE_MSG
539 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e ||
540 die_failed_squash $sha1 "$rest"
542 rm -f "$squash_msg" "$fixup_msg"
545 record_in_rewritten $sha1
548 read -r command rest < "$todo"
550 printf 'Executing: %s\n' "$rest"
551 # "exec" command doesn't take a sha1 in the todo-list.
552 # => can't just use $sha1 here.
553 git rev-parse --verify HEAD > "$state_dir"/stopped-sha
554 ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution
556 # Run in subshell because require_clean_work_tree can die.
558 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
559 if test "$status" -ne 0
561 warn "Execution failed: $rest"
563 warn "and made changes to the index and/or the working tree"
565 warn "You can fix the problem, and then run"
567 warn " git rebase --continue"
569 if test $status -eq 127 # command not found
574 elif test "$dirty" = t
576 warn "Execution succeeded: $rest"
577 warn "but left changes to the index and/or the working tree"
578 warn "Commit or stash your changes, and then run"
580 warn " git rebase --continue"
586 warn "Unknown command: $command $sha1 $rest"
587 fixtodo="Please fix this using 'git rebase --edit-todo'."
588 if git rev-parse --verify -q "$sha1" >/dev/null
590 die_with_patch $sha1 "$fixtodo"
596 test -s "$todo" && return
598 comment_for_reflog finish &&
599 newhead=$(git rev-parse HEAD) &&
602 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
603 git update-ref -m "$message" $head_name $newhead $orig_head &&
605 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
609 test ! -f "$state_dir"/verbose ||
610 git diff-tree --stat $orig_head..HEAD
613 test -s "$rewritten_list" &&
614 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
615 true # we don't care if this copying failed
617 if test -x "$GIT_DIR"/hooks/post-rewrite &&
618 test -s "$rewritten_list"; then
619 "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list"
620 true # we don't care if this hook failed
622 rm -rf "$state_dir" &&
624 warn "Successfully rebased and updated $head_name."
636 # skip picking commits whose parents are unchanged
637 skip_unnecessary_picks () {
639 while read -r command rest
641 # fd=3 means we skip the command
642 case "$fd,$command" in
644 # pick a commit whose parent is current $onto -> skip
646 case "$(git rev-parse --verify --quiet "$sha1"^)" in
662 printf '%s\n' "$command${rest:+ }$rest" >&$fd
663 done <"$todo" >"$todo.new" 3>>"$done" &&
664 mv -f "$todo".new "$todo" &&
665 case "$(peek_next_command)" in
667 record_in_rewritten "$onto"
670 die "Could not skip unnecessary pick commands"
673 # Rearrange the todo list that has both "pick sha1 msg" and
674 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
675 # comes immediately after the former, and change "pick" to
677 rearrange_squash () {
678 # extract fixup!/squash! lines and resolve any referenced sha1's
679 while read -r pick sha1 message
682 "squash! "*|"fixup! "*)
683 action="${message%%!*}"
684 rest="${message#*! }"
685 echo "$sha1 $action $rest"
686 # if it's a single word, try to resolve to a full sha1 and
687 # emit a second copy. This allows us to match on both message
689 if test "${rest#* }" = "$rest"; then
690 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
691 if test -n "$fullsha"; then
692 # prefix the action to uniquely identify this line as
693 # intended for full sha1 match
694 echo "$sha1 +$action $fullsha"
699 test -s "$1.sq" || return
702 while read -r pick sha1 message
705 *" $sha1 "*) continue ;;
707 printf '%s\n' "$pick $sha1 $message"
709 while read -r squash action msg_content
712 *" $squash "*) continue ;;
718 # full sha1 prefix test
719 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
721 # message prefix test
722 case "$message" in "$msg_content"*) emit=1;; esac ;;
724 if test $emit = 1; then
725 printf '%s\n' "$action $squash $action! $msg_content"
729 done >"$1.rearranged" <"$1"
730 cat "$1.rearranged" >"$1"
731 rm -f "$1.sq" "$1.rearranged"
734 # Add commands after a pick or after a squash/fixup serie
736 add_exec_commands () {
739 while read -r insn rest
747 printf "%s %s\n" "$insn" "$rest"
757 # do we have anything to commit?
758 if git diff-index --cached --quiet HEAD --
760 : Nothing to commit -- skip this
762 if ! test -f "$author_script"
764 die "You have staged changes in your working tree. If these changes are meant to be
765 squashed into the previous commit, run:
769 If they are meant to go into a new commit, run:
773 In both case, once you're done, continue with:
775 git rebase --continue
778 . "$author_script" ||
779 die "Error trying to find the author identity to amend commit"
782 current_head=$(git rev-parse --verify HEAD)
783 test "$current_head" = $(cat "$amend") ||
785 You have uncommitted changes in your working tree. Please, commit them
786 first and then run 'git rebase --continue' again."
787 do_with_author git commit --amend --no-verify -F "$msg" -e ||
788 die "Could not commit staged changes."
790 do_with_author git commit --no-verify -F "$msg" -e ||
791 die "Could not commit staged changes."
795 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
797 require_clean_work_tree "rebase"
806 sed -e '/^#/d' < "$todo" > "$todo".new
807 mv -f "$todo".new "$todo"
809 cat >> "$todo" << EOF
811 # You are editing the todo file of an ongoing interactive rebase.
812 # To continue rebase after editing, run:
813 # git rebase --continue
817 git_sequence_editor "$todo" ||
818 die "Could not execute editor"
824 git var GIT_COMMITTER_IDENT >/dev/null ||
825 die "You need to set your committer info first"
827 comment_for_reflog start
829 if test ! -z "$switch_to"
831 output git checkout "$switch_to" -- ||
832 die "Could not checkout $switch_to"
835 orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
836 mkdir "$state_dir" || die "Could not create temporary $state_dir"
838 : > "$state_dir"/interactive || die "Could not mark as interactive"
840 if test t = "$preserve_merges"
842 if test -z "$rebase_root"
844 mkdir "$rewritten" &&
845 for c in $(git merge-base --all $orig_head $upstream)
847 echo $onto > "$rewritten"/$c ||
848 die "Could not init rewritten commits"
851 mkdir "$rewritten" &&
852 echo $onto > "$rewritten"/root ||
853 die "Could not init rewritten commits"
855 # No cherry-pick because our first pass is to determine
856 # parents to rewrite and skipping dropped commits would
857 # prematurely end our probe
860 merges_option="--no-merges --cherry-pick"
863 shorthead=$(git rev-parse --short $orig_head)
864 shortonto=$(git rev-parse --short $onto)
865 if test -z "$rebase_root"
866 # this is now equivalent to ! -z "$upstream"
868 shortupstream=$(git rev-parse --short $upstream)
869 revisions=$upstream...$orig_head
870 shortrevisions=$shortupstream..$shorthead
872 revisions=$onto...$orig_head
873 shortrevisions=$shorthead
875 git rev-list $merges_option --pretty=oneline --abbrev-commit \
876 --abbrev=7 --reverse --left-right --topo-order \
879 while read -r shortsha1 rest
882 if test -z "$keep_empty" && is_empty_commit $shortsha1 && ! is_merge_commit $shortsha1
889 if test t != "$preserve_merges"
891 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
893 sha1=$(git rev-parse $shortsha1)
894 if test -z "$rebase_root"
897 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
899 if test -f "$rewritten"/$p
907 if test f = "$preserve"
909 touch "$rewritten"/$sha1
910 printf '%s\n' "${comment_out}pick $shortsha1 $rest" >>"$todo"
915 # Watch for commits that been dropped by --cherry-pick
916 if test t = "$preserve_merges"
919 # Save all non-cherry-picked changes
920 git rev-list $revisions --left-right --cherry-pick | \
921 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
922 # Now all commits and note which ones are missing in
923 # not-cherry-picks and hence being dropped
924 git rev-list $revisions |
927 if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
929 # Use -f2 because if rev-list is telling us this commit is
930 # not worthwhile, we don't want to track its multiple heads,
931 # just the history of its first-parent for others that will
932 # be rebasing on top of it
933 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
934 short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev)
935 sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
941 test -s "$todo" || echo noop >> "$todo"
942 test -n "$autosquash" && rearrange_squash "$todo"
943 test -n "$cmd" && add_exec_commands "$todo"
945 cat >> "$todo" << EOF
947 # Rebase $shortrevisions onto $shortonto
950 cat >> "$todo" << EOF
952 # However, if you remove everything, the rebase will be aborted.
956 if test -z "$keep_empty"
958 echo "# Note that empty commits are commented out" >>"$todo"
962 has_action "$todo" ||
963 die_abort "Nothing to do"
965 cp "$todo" "$todo".backup
966 git_sequence_editor "$todo" ||
967 die_abort "Could not execute editor"
969 has_action "$todo" ||
970 die_abort "Nothing to do"
972 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
974 output git checkout $onto || die_abort "could not detach HEAD"
975 git update-ref ORIG_HEAD $orig_head